//---------------------------------------------------------------------------
#ifndef jasenfH
#define jasenfH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include "jasen.h"
#include "kerho.h"
#define LKM 15
//---------------------------------------------------------------------------
class TJasenForm : public TForm
{
__published:	// IDE-managed Components
	TButton *OKbutton;
	TButton *CancelButton;
	void __fastcall Edit1Change(TObject *Sender);

	void __fastcall Edit1Exit(TObject *Sender);
	void __fastcall CancelButtonClick(TObject *Sender);

    void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
    void __fastcall OKbuttonClick(TObject *Sender);
    void __fastcall FormDeactivate(TObject *Sender);
private:
	TLabel *labels[LKM];
    TEdit *edits[LKM];
    bool kaytossa;    // Onko lomake kytss vai ei
    bool talleta;     // Pitk tiedot tallettaa jseneen (Cancel => ei)
    bool saa_poistua; // Voiko tarkistajan mielest sulkea lomakkeen
    bool muutos;
	bool korjaa;	  // jos true niin voidaan muuttaa annettua jsent
    bool muutettu;    // jos tietoja muutettu lomakkeen ollessa auki
    bool djasen;      // Onko jsen dynaaminen vai ei
    cJasen *jasen;
    cKerho *kerho;
    int paikka;		  // Jsenen paikka nro kerhossa
    void nayta_kentat(bool readonly=false);
    void tarkista(TEdit *edit, int nro);
    bool tarkista_kokonaan(TEdit *edit, int nro);
    void alusta(cKerho *k);
    bool Erilainen(TEdit *Edit); 
    bool TarkistaEdit(TEdit *Edit);
public:
	int muuta(cJasen &jas, cKerho *k, const char *viesti=NULL);
    int kysy(cJasen &jas);
    bool voiko_sulkea();
    bool nayta(int p, cJasen &jas);
	__fastcall TJasenForm(TComponent* Owner, cKerho *k);
	__fastcall TJasenForm(TComponent* Owner) : TForm(Owner) { alusta(NULL); }
};
//---------------------------------------------------------------------------
extern TJasenForm *JasenForm;
//---------------------------------------------------------------------------
#endif
