//---------------------------------------------------------------------------
// Winkerho v1.0 (c) Tommi Lahtonen & Vesa Lappalainen 7.9.199
// muutokset vanhaan kerho-ohjelman DOS-versioon:
// mjonotpp.h	listty rivi: using namespace std;
// mjonotpp.cpp listty rivi: #define NPOS -1
/* kerhowin.cpp */
/****************************************************************************/
/*
** TNaytto-luokan toteutus 	(korvaa vanhan naytto-luokan)
**
**  Tekijt:          Tommi Lahtonen
**  Tehty:            Huhtikuu 1997
**
**  Muutettu:         07.9.1997
**  Mit muutettu:    Pient viimeistely
**
	void __fastcall FormShow(TObject *Sender);
          luetaan kerho levylt tai luodaan uusi. Pivitetn kerhon jsenet
          listaboksiin.
	void __fastcall AvustusButtonClick(TObject *Sender);
		  Nytt avustuksen ( ei tehty viel)
	void __fastcall LopetusButtonClick(TObject *Sender);
			Lopettaa ohjelman ja haluttaessa tallettaa kerhon.
	void __fastcall LisaaButtonClick(TObject *Sender);
    		Lis kerhoon uuden jsenen.
	void __fastcall EtsiButtonClick(TObject *Sender);
    		Etsii jsenen kerhosta ( ei tehty viel )
	void __fastcall TulosteetButtonClick(TObject *Sender);
    		Tulosteet ( ei tehty viel )
	void __fastcall PaivitaButtonClick(TObject *Sender);
			Pivitt jsenmaksuja ( ei tehty viel )
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
    		Sulkee ohjelman ja tarvittaessa tallettaa kerhon
	void __fastcall JasenBoxClick(TObject *Sender);
    		Nytt valitun jsenen tiedot ja mahdollistaa niiden muuttamisen
	void __fastcall About1Click(TObject *Sender);
    		Nytt About-demon
    void lisaa_uusi_jasen(char valinta=' ');
    		Lis uuden jsenen.
     __fastcall TNaytto(TComponent* Owner);
			Luo uuden kerhon
    int  lue_tiedosto(const char *tied_nimi=NULL);
    		Lukee kerhon levylt tai luo uuden
    int  kysy_talleta();
    		Kysyy talletetaanko kerho
    void PaivitaListbox();
    		Pivitt kerhon jsenet listaboksiin
    int  talleta();
			Tallettaa kerhon

*/
#include <vcl\vcl.h>
#pragma hdrstop

#include <strstrea.h>
#include "kerhowin.h"
#include "ohjetus.h"
#include "kysydlg.h"
#include "help.h"
#include "editlue.h"
#include "omat.h"
#include "jasenf.h"
#include "demo.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TNaytto *Naytto;

#define VERSIO "1998.01.18"

static const int   OLET_ALKU = 19;
static const int   VAKANEN   = 33;
static const char *TARKENNIN = ".dat";
static const char *VANHATARK = ".bak";
/*
typedef struct {
  eToiminto komento;
  const char *jono;
} tKomento;

static tKomento komennot[] = {
  { TOIM_LOPETA      , "q"   },
  { TOIM_EDELLINEN   , "^"   },
  { TOIM_LOPUT_OLETUS, ",|." },
  { TOIM_JATKA       , NULL  }
};
static eToiminto mika_komento(const char *s)
{
  for (int i=0; komennot[i].jono; i++)
    if ( joku_jono(s,komennot[i].jono,"|") == 0 ) return komennot[i].komento;
  return TOIM_JATKA;
}
*/
//---------------------------------------------------------------------------
__fastcall TNaytto::TNaytto(TComponent* Owner)
	: TForm(Owner)
{
  kerho = new cKerho;
  JasenForm = new TJasenForm(this, kerho);
  ohjelman_nimi = "kerho";
  nykyjasen = -1;
  alusta_help(ohjelman_nimi.c_str());
  edit_alusta("kerho.lyh");
}

//---------------------------------------------------------------------------
void __fastcall TNaytto::FormShow(TObject *Sender)
{
  if ( lue_tiedosto() != 0 ) Close();
  PaivitaListbox();
}
//---------------------------------------------------------------------------
int ilmoitus(const string &s) {return ilmoitus(s.c_str());}

//---------------------------------------------------------------------------
int TNaytto::lue_tiedosto(const char *tied_nimi)
/*
** Luetaan kerho levylt.
** Ensin kysytn kerhon nimi.  Jos kerhoa ei ole, utellaan
** listietoja ja luodaan se.
----------------------------------------------------------------------------*/
{
  string tied,nimi; int maksimi;

  do { // Kyselln kunnes tiedosto aukeaa tai luodaan uusi
  	if (!KysyTiedosto->Execute()) return ilmoitus("Tiedoston nime ei annettu");
//	kysy("Anna kerhon nimi", tied);
	tied = KysyTiedosto->FileName.c_str();
    if ( tied == "" ) return ilmoitus("Tiedoston nime ei annettu");
    laita_tarkennin(tied,TARKENNIN);
    if ( onko_tiedostoa(tied) ) return ilmoitus(kerho->lue_tiedostosta(tied));

    string apu = "Tiedostoa " + tied + " ei ole!" ;
    ilmoitus(apu.c_str());

  } while ( kylla_kysymys("Luodaanko uusi tiedosto?") == 0 );
  kysy("Anna kerhon koko nimi    >", nimi);
  kysy("Anna kerhon maksimi koko >",maksimi);

  return ilmoitus(kerho->luo(tied,nimi,maksimi));
}


//---------------------------------------------------------------------------
void __fastcall TNaytto::LopetusButtonClick(TObject *Sender)
{
  Close();//lopetus();
}
//---------------------------------------------------------------------------
void __fastcall TNaytto::LisaaButtonClick(TObject *Sender)
{
  lisaa_uusi_jasen();
  PaivitaListbox();
}
//---------------------------------------------------------------------------
void __fastcall TNaytto::EtsiButtonClick(TObject *Sender)
{
  ei_toimi();
}
//---------------------------------------------------------------------------
void __fastcall TNaytto::TulosteetButtonClick(TObject *Sender)
{
  ei_toimi();
}
//---------------------------------------------------------------------------
void __fastcall TNaytto::KorjaaButtonClick(TObject *Sender)
{
  ei_toimi();
}
//---------------------------------------------------------------------------
void __fastcall TNaytto::PaivitaButtonClick(TObject *Sender)
{
  ei_toimi();
}
//---------------------------------------------------------------------------

int TNaytto::kysy_talleta()
{
  if ( !kerho->Muutettu() ) return 0;
  if ( kylla_kysymys("Talletetaanko tiedot") ) return talleta();
  return 0;
}
//---------------------------------------------------------------------------
int TNaytto::talleta()
/*
** Jos kerhossa muutoksia, niin
** Nimetn vanha tiedosto .bak -nimelle ja talletetaan
** nykyinen tiedosto vanhan tilalle.
----------------------------------------------------------------------------*/
{
//  logo();
  if ( !kerho->Muutettu() ) return 0;
  int vanhat_pilalla = kerho->TeeBak(VANHATARK);

  if ( ilmoitus(kerho->talleta()) ) return 1;

  string apu = "Tiedot talletettu tiedostoon " +
                kerho->Jasenet().Tiedoston_nimi() + "\n";
  if ( !vanhat_pilalla ) {
  	apu = apu + "\n" +
          "Vanhat tiedot tiedostossa    " +
          kerho->Jasenet().Bak_nimi() + "\n";
  }
  ilmoitus(apu);

  return 0;
}

//---------------------------------------------------------------------------
void __fastcall TNaytto::FormClose(TObject *Sender, TCloseAction &Action)
{
  kysy_talleta();
  edit_vapauta("kerho.lyh");
  vapauta_help();
}

//---------------------------------------------------------------------------
void TNaytto::PaivitaListbox()
{
  JasenBox->Items->Clear();
  for (int i=0; i<kerho->Jasenia(); i++) {
    const cJasen &jasen = kerho->Jasenet().anna(i);
    string apu = jasen.kentta_jonoksi(1);
    JasenBox->Items->Add(apu.c_str());
//    if (JasenForm->kysy(jasen)!=mrOk) return;
  }
  JasenBox->ItemIndex = nykyjasen;
}

void TNaytto::lisaa_uusi_jasen(char valinta)
/*
** Kyselln uusien jsenien tietoja ja listn jsenet.
----------------------------------------------------------------------------*/
{
  cJasen jasen(kerho->Jasenet().anna(nykyjasen));  // Kerho hoitaa jos -1
  TJasenForm *uusiform = new TJasenForm(this,kerho);
  if (!uusiform) return;

  jasen.tyhjenna_omat();
  jasen.rekisteroi();
  int ok = uusiform->muuta(jasen, kerho,"Lis uusi jsen");
  delete uusiform;

  if ( ok != mrOk) return;
  if ( ilmoitus(kerho->Jasenet().lisaa(jasen)) ) return;

  Caption = "Rekisteri, jseni : " + IntToStr(kerho->Jasenia());
  nykyjasen = kerho->Jasenia()-1;
  PaivitaListbox();
//  JasenBox->ItemIndex = nykyjasen;
  JasenBoxClick(JasenBox);
}
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
void __fastcall TNaytto::JasenBoxClick(TObject *Sender)
{
  int nr = JasenBox->ItemIndex;
  if ( nr == -1 ) return;
  const cJasen &jas = kerho->Jasenet().anna(nr);
  if ( JasenForm->nayta(nr,jas) ) nykyjasen = nr;
  JasenBox->ItemIndex = nykyjasen;
  SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TNaytto::About1Click(TObject *Sender)
{
  Demotus->ShowModal();
}
//---------------------------------------------------------------------------
void __fastcall TNaytto::AvustusButtonClick(TObject *Sender)
{
  Ohjeet->Show();
}
//---------------------------------------------------------------------------


