//---------------------------------------------------------------------------
#ifndef kerhowinH
#define kerhowinH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\Menus.hpp>
#include <vcl\Dialogs.hpp>
#include "jasenf.h"
//---------------------------------------------------------------------------
typedef enum {
  TOIM_JATKA,
  TOIM_SEURAAVA,
  TOIM_EDELLINEN,
  TOIM_KYSY_UUDELLEEN,
  TOIM_LOPUT_OLETUS,
  TOIM_LOPETA
} eToiminto;

class TNaytto : public TForm
{
__published:	// IDE-managed Components
	TButton *AvustusButton;
	TButton *LopetusButton;
	TButton *EtsiButton;
	TButton *TulosteetButton;
	TButton *PaivitaButton;
	TButton *LisaaButton;
	TListBox *JasenBox;
	TMainMenu *MainMenu1;
	TMenuItem *Toiminnot;
	TMenuItem *Lopetus;
	TMenuItem *Etsijsenentiedot1;
	TMenuItem *tulosteet1;
	TMenuItem *tietojenkorjailu1;
	TMenuItem *pivitjsenmaksuja1;
	TMenuItem *Lopetus1;
	TMenuItem *Help;
	TMenuItem *About1;
	TOpenDialog *KysyTiedosto;
	void __fastcall FormShow(TObject *Sender);
	void __fastcall LopetusButtonClick(TObject *Sender);
	void __fastcall LisaaButtonClick(TObject *Sender);
	void __fastcall EtsiButtonClick(TObject *Sender);
	void __fastcall TulosteetButtonClick(TObject *Sender);
	void __fastcall KorjaaButtonClick(TObject *Sender);
	void __fastcall PaivitaButtonClick(TObject *Sender);
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
	void __fastcall JasenBoxClick(TObject *Sender);
	void __fastcall About1Click(TObject *Sender);
	void __fastcall AvustusButtonClick(TObject *Sender);
    
private:	// User declarations
  TJasenForm *JasenForm;
  cKerho *kerho; // Osoitin kerhoon => voi olla sama kerho monessa nytss
  int nykyjasen;
  string ohjelman_nimi; // Esim. help-toimintoa varten
  void lisaa_uusi_jasen(char valinta=' ');
public:		// User declarations
  __fastcall TNaytto(TComponent* Owner);
  int  lue_tiedosto(const char *tied_nimi=NULL);
  int  kysy_talleta();
  void PaivitaListbox();
  int  talleta();
};
//---------------------------------------------------------------------------
extern TNaytto *Naytto;
//---------------------------------------------------------------------------
#endif
